/* Open slot, then get rotary ID position. 

   Author: Moki Matsushima  

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 

    File level history (record changes for this file here.)
    rotary_id.c   
    v 1.0.0  1 January 2010 by Cindy Huang
   
*/
   
#include<stdio.h>
#include<stdlib.h>

#include "msw.h"


void	usage(void);
int main(int argc, char **argv)
{
	int wRetVal, type, slot;
  unsigned int id;
  
  if (argc == 2) {
	   type=atoi(argv[1]);
	}
	else{ 
	    usage();
	    return (-1);
	}
	
	
	switch(type){
  	case 1:	  
      slot = 0;  //lp-8x4x,pds-8x2,vp-25a1
			break;
  	case 2:	  
      slot = 8;  
			break;
		default:  
		  slot = 0; 
			break;
	}
	
	wRetVal = Open_Slot(slot);
	
  if (wRetVal > 0) {
		  printf("open Slot%d failed!\n",slot);
		  return (-1);
  }
  
	GetRotaryID(type,&id);
  printf("GetRotary ID = %d \n",id);
   
  Close_Slot(slot);
	return 0;
}

void usage(void)
{
    printf("Function: rotary_id                                 \n");
		printf("Get rotary ID position                              \n");
		printf("Usage: rotary_id.exe type                           \n");
		printf("Type definition: LP-8x4x,PDS-8x2,VP-23/25L1 --> 1   \n");
		printf("                 LP-5000                    --> 2   \n");
			printf("Example: rotary_id.exe 1                            \n");
		printf("Open slot to get rotary ID position for LinPAC-8x4x \n");
}
