/* Example of XW107 OR XW107i for LinPAC.

   Author: Moki Matsushima

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */

/* File level history (record changes for this file here.)

   v 0.0.0  1 Sep 2009 by Cindy Huang
     create, blah blah... */
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include "msw.h"
#include "xwboard.h"
#include "xw107.h"


int main()
{
   unsigned int quit=0, type, ret, iStatus, iDIValue, iDOValue, iInChannel, iOutChannel;
   
   if (Open_Slot(1)) 
   {
	   printf("open Slot 1 failed!\n");
	   return FAILURE;
	 }
	 XW107_Init();    //Initialize the X107    
	 
   while (quit!=1)
   {
      printf("\n\r");
      printf("   Demo program for LinPAC-5000 + XW107/XW107i   \n\r");
      printf("=================================================\n\r");
      printf(" Please choose one of the following :            \n\r");
      printf("        0.) Exit.                                \n\r");    
      printf("        1.) Read All DI channels.                \n\r");   
      printf("        2.) Read One DI channel.                 \n\r"); 
      printf("        3.) Write All DO channels.               \n\r");
      printf("        4.) Write One DO channel.                \n\r"); 
      printf("        5.) DO Readback All channels.            \n\r");
      printf("        6.) DO Readback One channel.             \n\r");
      printf(" Note:DI(Ch0~Ch7);DO(Ch0~Ch7)                    \n\r");
      printf("=================================================\n\r");
      printf("Choose an option and press [Enter]:");
      scanf("%d",&type);
   
      /* open device file  */
  
      switch (type)
      {
         case 0:     //exit               
            quit=1;       
            break;  
        
         case 1:  //Read all DI ReadBack       // All for DO type (Ch0~Ch15)  
            iDIValue=XW107_Read_All_DI();
            printf("Input value=> 0x%02x\r\n\r\n", iDIValue);
        
            break; 
            
        case 2:  //Read single DI ReadBack         // All for DI type (Ch0~Ch15)
            printf("Please select DI channel(0~7): ");
            scanf("%d:",&iInChannel);
        
            if ((iInChannel<0) ||(iInChannel>7))
            {  
              printf("Out of range!\n");
              return FAILURE; 
            }
        
            iDIValue=XW107_Read_One_DI(iInChannel);
                
            if(iDIValue)
                printf("Channel %d ==> OFF\r\n", iInChannel);
            else
                printf("Channel %d ==> ON\r\n", iInChannel);

            break;
        
        case 3:     //Write all DO channels                
            printf("Please input Output value(0x00~0xff): ");
            scanf("%x:",&iDOValue);
        
            if ((iDOValue<0)||(iDOValue>255))
            {
              printf("Out of range!");
              return FAILURE; 
            }
              
            XW107_Write_All_DO(iDOValue);
            printf("Output value=> 0x%02x\r\n", iDOValue);
                          
            break;  
        
       case 4:     //Write single DO channel                
            printf("Please select output channel(0~7): ");
            scanf("%d:",&iOutChannel);
            printf("Please input channel status(0:OFF, 1:ON): ");
            scanf("%x:",&iStatus);
        
            if ((iOutChannel<0)||(iOutChannel>7)||(iStatus<0)||(iStatus>1))
            {
              printf("Out of range!\n");
              return FAILURE; 
            }
              
            XW107_Write_One_DO(iOutChannel, iStatus);                      
				    printf("Channel %d ==> %s\r\n\r\n", iOutChannel, (iStatus>=1)?"ON":"OFF");
				            
            break;
            
        case 5:     //Read all DO ReadBack
            iDOValue=XW107_Read_All_DO();      
            printf("Digital Output ReadBack=> 0x%02x\r\n", iDOValue);
            break;
        
        case 6:   //Read single DO ReadBack
            printf("Please select outport channel(0~7): ");
            scanf("%d", &iOutChannel);
                                
            if((iOutChannel<0)||(iOutChannel>7))
            {
              printf("Out of range!\r\n");
              break;
            } 
                
            ret=XW107_Read_One_DO(iOutChannel);                                         
            if(ret)
              printf("Channel %d ==> ON\r\n", iOutChannel);
            else
              printf("Channel %d ==> OFF\r\n", iOutChannel);
      
            break;
      }
  } 

	Close_Slot(1);
	return 0;
}
