/* Example of xw110 for LinPAC.

   Author: Moki Matsushima

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */

/* File level history (record changes for this file here.)

   v 0.0.0  1 Sep 2009 by Cindy Huang
     create, blah blah... */
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include "msw.h"
#include "xwboard.h"
#include "xw110.h"


int main()
{
   unsigned int  quit=0, type, ret, iStatus, iDIValue, iDOValue, iInChannel, iOutChannel;
  
  /* open device file  */
   if (Open_Slot(1)>0) 
   {
	    printf("open Slot failed!\n");
	    return FAILURE;
	 }
	 ret=XW110_Init();
   if (ret!=0){  //Initialize the X110
      printf("Cannot find XW110 or XW110i!\n" ); 
      return FAILURE;  
	 }
	 
   while (quit!=1)
   {  
      printf("\n\n");
      printf("    Demo program for LinPAC-5000 + XW110/XW110i   \n\r");
      printf("==================================================\n\r");
      printf(" Please choose one of the following :             \n\r");
      printf("        0.) Exit.                                 \n\r");  
      printf("        1.) Read All DI channels.                 \n\r");   
      printf("        2.) Read One DI channel.                  \n\r"); 
      printf("==================================================\n\r");
      printf("Choose an option and press [Enter]:");
      scanf("%d",&type);
      if (type > 3){
          printf("Please type again !");
      }else {
          switch (type)
          {
              case 0:  //exit 
                  quit=1;
                  break; 
          
              case 1:  //Read all DI ReadBack        
                  iDIValue=XW110_Read_All_DI();
                  printf("Input value=> 0x%04x\n\n", iDIValue);
              break; 
          
              case 2:  //Read single DI ReadBack        
                  printf("Please select DI channel(0~15): ");
                  scanf("%d:",&iInChannel);
        
                  if ((iInChannel<0) ||(iInChannel>15))
                  {  
                      printf("Out of range!\n");
                      return FAILURE; 
                  }
        
                  iDIValue=XW110_Read_One_DI(iInChannel);
                
                  if(iDIValue)
                        printf("Channel %d ==> OFF\r\n", iInChannel);
                  else
                        printf("Channel %d ==> ON\r\n", iInChannel);
                  break;
            }
      }
  }
	Close_Slot(1);
	return 0;
}
